#include "gn/gnSequence.h"

// This short sample program demonstrates some of the basic functionality
// available in libGenome.  See the API documentation for further details

int main( void )
{
	// define a string to store the sequence file name
	string filename;
	// define a gnSequence to store the sequence
	gnSequence file_sequence;

	// Get the name of the sequence to load
	cout << "Enter the name of the sequence file to load:\n" ;
	cin >> filename;
	
	// Load the sequence and tell the user if it loaded successfully
	try{
		file_sequence.LoadSource(filename);
		cout << filename << " loaded successfully " << file_sequence.length() << " base pairs in " << file_sequence.contigListSize() << " contigs.\n";
	}catch(gnException& e){
		// Find out what kind of error occurred.
		if(e.GetCode() == FileNotOpened()){
			cout << "Unable to open file\n";
			cout << e;
		}else{
			cout << "Error loading file\n";
			cout << e;
		}
		cin >> filename;
		return -1;
	}
	
	try{
		// output the first ten bases of the sequence
		cout << file_sequence.subseq(1,10);

		// add some bases to the end of the sequence
		file_sequence += "CATGATCATGAT";
		
		// insert some bases before base pair 10
		file_sequence.insert(10, "ACGTACGTA");
		
		// delete the last 15 base pairs
		file_sequence.erase(file_sequence.length()-15, 15);
	}catch(gnException& e){
		cout << "An error occurred.\n";
		cout << e;
		cin >> filename;
		return -1;
	}
	cin >> filename;
	return 0;
}